/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui;

import gui.layout.AnchorLayout;
import gui.layout.AnchorParam;
import gui.util.buttonhandler.ButtonHandler;

import java.awt.BorderLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;


import static init.JID2.rm;


public class SubdirPanel extends JPanel {

	private static final long serialVersionUID = 1L;
	private JRadioButton customSubdir;
	private ButtonHandler radioButtonHandler;
	private JTextField txtCustomOutput;
	
	public SubdirPanel() {
		JRadioButton noSubDir=new JRadioButton(rm().getLocalizedString("noSubdir"));
		JRadioButton hosterSubDir=new JRadioButton(rm().getLocalizedString("hosterSubdir"));
		customSubdir=new JRadioButton(rm().getLocalizedString("customSubdir"));
		JRadioButton optByURL=new JRadioButton(rm().getLocalizedString("urlSubdir"));
		txtCustomOutput=new JTextField();
		setLayout(new AnchorLayout());
		setBorder(BorderFactory.createTitledBorder(rm().getLocalizedString("subdir")));
		
		JPanel customSubdirPanel=new JPanel();
		
		customSubdirPanel.setLayout(new BorderLayout());
		customSubdirPanel.add(customSubdir,BorderLayout.WEST);
		customSubdirPanel.add(txtCustomOutput,BorderLayout.CENTER);
		
		JPanel p=new JPanel(new AnchorLayout());
		AnchorParam h=AnchorParam.height(24);
		p.add(noSubDir,AnchorLayout.getConstraints(AnchorParam.left(5),AnchorParam.top(0),h));
		p.add(hosterSubDir,AnchorLayout.getConstraints(AnchorParam.left(110),AnchorParam.top(0),h));
		p.add(optByURL,AnchorLayout.getConstraints(AnchorParam.left(5),AnchorParam.bottom(0),h));
		p.add(customSubdirPanel,AnchorLayout.getConstraints(AnchorParam.left(110),AnchorParam.bottom(0),h,AnchorParam.right(5)));

		
		add(p,AnchorLayout.getConstraints(AnchorParam.left(5),AnchorParam.right(5),AnchorParam.height(50)));
		radioButtonHandler=new ButtonHandler();
		
		radioButtonHandler.add(noSubDir,hosterSubDir,customSubdir,optByURL);
		
		txtCustomOutput.addMouseListener(new MouseAdapter() {
			
			@Override
			public void mousePressed(MouseEvent e) {
				radioButtonHandler.setSelectedButton(customSubdir);
			}
		});
		
	}
	
	public void setSelectedSubdirOption(int index) {
		radioButtonHandler.setSelectedButton(index);
	}
	
	public int getSelectedSubdirOption() {
		return radioButtonHandler.getSelectedIndex();
	}

	public void setCustomSubdir(String s) {
		txtCustomOutput.setText(s);
	}
	
	public String getCustomSubdir() {
		return txtCustomOutput.getText();
	}
	
	public String getSubdir() {
		int opt=radioButtonHandler.getSelectedIndex();
		
		if (opt==0) {
			return null;
		} else if (opt==1) {
			return "<HOSTER>";
		} else {
			return txtCustomOutput.getText();
		}
	}

	
}
