/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.settings;

import settings.Settings;
import core.io.Application;
import init.JID2;
import gui.layout.AnchorLayout;
import gui.layout.AnchorLayoutConstraints;
import gui.layout.AnchorParam;
import gui.resource.ResourceManager;
import gui.settings.dialog.component.PathSettingsComponent;
import gui.settings.dialog.component.SpinnerSettingsComponent;
import gui.settings.dialog.group.SettingsComponentGroup;
import gui.settings.dialog.page.SettingsPage;

public class DownloadsSettingPage extends SettingsPage {

	private static final long serialVersionUID = 1587025121820132146L;

	public DownloadsSettingPage(String entry,Application app) {
		super(entry,app);
	}

	@Override
	protected void createComponentGroups(Settings s,ResourceManager rm) {
		setLayoutMgr(2);
		SettingsComponentGroup threadSettingsGroup=new ThreadsSettingsGroup();
		addSettingsComponentGroup(threadSettingsGroup);
		addSettingsComponentGroup(new PathSettingsGroup( rm.getLocalizedString(JID2.LOCALE_PATH)));
		
	}
	
	private class ThreadsSettingsGroup extends SettingsComponentGroup {

		private static final long serialVersionUID = -2239382458872983954L;

		public ThreadsSettingsGroup() {
			super("Threads", JID2.rm());
		}

		@Override
		protected void createSettingsComponents(ResourceManager rm) {
			SpinnerSettingsComponent c = new SpinnerSettingsComponent(JID2.SETTING_THREADS);
			setLayout(new AnchorLayout());
			addSettingsComponent(c,AnchorLayoutConstraints.getBySize(100,24));
			
		}
		
	}
	
	private class PathSettingsGroup extends SettingsComponentGroup{
		private static final long serialVersionUID = -863607593201676382L;

		public PathSettingsGroup(String title) {
			super(title, JID2.rm());
		}

		@Override
		protected void createSettingsComponents(ResourceManager rm) {
			setLayout(new AnchorLayout());
			addSettingsComponent(new PathSettingsComponent(JID2.SETTING_PATH,null),AnchorLayout.getConstraints(AnchorParam.left(20),AnchorParam.right(20),AnchorParam.height(24)));
		}
	}
}