/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.settings;

import settings.Settings;
import core.io.Application;
import init.JID2;
import gui.resource.ResourceManager;
import gui.settings.dialog.group.CheckboxSettingsGroup;
import gui.settings.dialog.group.LanguageSettingsGroup;
import gui.settings.dialog.page.SettingsPage;


public class GeneralSettingsPage extends SettingsPage {
	private static final long serialVersionUID = 8527495237467708113L;

	public GeneralSettingsPage(String entry,Application app) {
		super(entry,app);
	}

	@Override
	protected void createComponentGroups(Settings s,ResourceManager rm) {
		setLayoutMgr(2);
		addSettingsComponentGroup(new LanguageSettingsGroup(JID2.getInstance().getLocales(), rm));
		addSettingsComponentGroup(new CheckboxSettingsGroup(
			rm.getLocalizedString("borderUpdate"),
			rm.getLocalizedString("settingUpdate"),
			"updateOnStartup", rm)
		);
	}

}
