package gui.util;

import java.awt.FontMetrics;
import java.awt.Graphics;

import javax.swing.Icon;
import javax.swing.JLabel;

public class MultiLineJLabel extends JLabel{

	private static final long serialVersionUID = 2666324613530971914L;
	private String originalText;
	
	public MultiLineJLabel() {
		super();
	}


	public MultiLineJLabel(Icon image, int horizontalAlignment) {
		super(image, horizontalAlignment);
	}


	public MultiLineJLabel(Icon image) {
		super(image);
	}


	public MultiLineJLabel(String text, Icon icon, int horizontalAlignment) {
		super(text, icon, horizontalAlignment);
	}


	public MultiLineJLabel(String text, int horizontalAlignment) {
		super(text, horizontalAlignment);
	}


	public MultiLineJLabel(String text) {
		super(text);
	}


	@Override
	protected void paintComponent(Graphics g) {
		FontMetrics m= g.getFontMetrics();
		
		StringBuilder sb=new StringBuilder("<html>");
		int w=0;
		for (int i=0;i<originalText.length();i++){
			char c=originalText.charAt(i);
			int charW=m.charWidth(c);
			w+=charW;
			if (w>getWidth()){
				int k=sb.lastIndexOf("\u0020");
				int j=0;
				
				if (k>-1) {
					j=m.stringWidth(sb.substring(k));
					sb.replace(k, k+1, "<br/>");
				}
				w=j+charW;
			}
			sb.append(c);
		}
		
		sb.append("</html>");
		super.setText(sb.toString());
		super.paintComponent(g);
	}
	
	public String getOriginalText() {
		return originalText;
	}
	
	@Override
	public void setText(String text) {
		originalText=text;
		super.setText(text);
	}
}
