/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package init;


import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Collection;
import java.util.List;

import model.DLInfo;
import model.DownloadManager;
import model.JIDModel;
import model.transfer.TransferInfo;

import gui.resource.ResourceManager;
import settings.Settings;
import util.exception.CancelException;
import core.io.Application;

public class JID2 extends Application{

	private static JID2 instance;
	
	public static final String 	SETTING_THREADS="maxThreads",
			SETTING_TIMEOUT="timeout",
			SETTING_MODIFIERS="modifiers",
			SETTING_LOOK_AND_FEEL = "lookAndFeel",
			SETTING_WIDTH="windowWidth",
			SETTING_HEIGHT="windowHeight",
			SETTING_X="windowX",
			SETTING_Y="windowY",
			SETTING_TOOLBAR="toolbarOption",
			SETTING_WINDOW_STATE=	"windowState",
			SETTING_PATH="outputDir",
			SETTING_COL_POS="columnPos",
			SETTING_COL_WIDTH="columnWidth",
			SETTING_LOG_DIVIDER_LOCATION="tableLogDividerLocation",
			SETTING_SUBDIR_OPTION_ENTER="subdirOption",
			SETTING_CUSTOM_SUBDIR_ENTER="customSubdir",
			SETTING_ENTER_LINKS_WINDOW_X="enterLinksWindowX",
			SETTING_ENTER_LINKS_WINDOW_Y="enterLinksWindowY",
			SETTING_ENTER_LINKS_WINDOW_WIDTH="enterLinksWindowWidth",
			SETTING_ENTER_LINKS_WINDOW_HEIGHT="enterLinksWindowHeight",
			SETTING_URL_CB="monitorClipboard",
			SETTING_AUTO_LOAD_URL="autoLoad",
			SETTING_ENTER_WINDOW_ON_TOP="extractDialogOnTop",
			SETTING_TRIES="maxTries"
			;

	public static final String 	LOCALE_PROXY_ENABLED ="settingProxyEnabled",
		   	LOCALE_PROXY_HOST="settingProxyHost",
		   	LOCALE_PROXY_PORT="settingProxyPort",
		   	LOCALE_TIMEOUT="settingTimeout",
		   	LOCALE_LINK_TOKEN="settingLinkToken",
		   	LOCALE_VIEW_LINK_TOKEN="settingViewLinkToken",
		   	LOCALE_EMPTY_NODE = "emptyNode",
		   	LOCALE_PATH="settingOutput",
		   	LOCALE_BORDER_PATHS="borderPaths"
		   	;
	
	
	public JID2(String subDir,String settingsFile) throws IOException, CancelException {
		super(subDir, settingsFile, true);
		instance=this;
		JIDModel.init(settings);
	}
	
	public static Settings settings() {
		return instance.getSettings();
	}
	
	public static JID2 getInstance() {
		return instance;
	}
	
	public static ResourceManager rm() {
		return instance.getResourceManager();
	}
	
	
	public void saveSession(DownloadManager dm) throws IOException {
		Path p=execPath.resolve("session.dat");
		Collection<TransferInfo> list=dm.getUnfinished();
		OutputStream out=new BufferedOutputStream(Files.newOutputStream(p, Application.DEFAULT_WRITE_OPTIONS));
		for (TransferInfo ti: list)
		{
			DLInfo di=(DLInfo) ti;
			out.write(di.getUrl().getBytes(Application.UTF8));
			out.write('>');
			out.write(di.getOutputPath().toString().getBytes(Application.UTF8));
			out.write('\n');
		}
		out.close();
	}
	
	public void loadSession(DownloadManager dm) throws IOException, CancelException{
		Path p=execPath.resolve("session.dat");
		if (Files.exists(p)) {
			List<String> list=Files.readAllLines(p, Application.UTF8);
			for (String l:list) {
				String[] t=l.split(">");
				if (t.length==2)
					dm.addDownload(new DLInfo(t[0], Paths.get(t[1])));
			}
		}
	}
	
	@Override
	protected void setAdditionalDefaultSettings() {
		//settings.set(SETTING_PATH, execPath.resolve("output"));
		settings.set(SETTING_PATH, "output");
	}

	@Override
	public String getVersion() {
		return "1.9.1";
	}
}
