/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package io;

import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import io.downloaders.action.Action;
import model.DLInfo;
import model.transfer.TransferEngine;
import model.transfer.TransferInfo;
import model.urlconfig.URLConfig;

public class DefaultDownloaderConfig3 implements IDownloaderConfig{

	private List<Action> actions;
	private List<URLConfig> urlConfigs;
	
	public DefaultDownloaderConfig3() {
		actions = new LinkedList<Action>();
		urlConfigs=new LinkedList<URLConfig>();
	}
	
	public void addUrlConfig(URLConfig c) {
		urlConfigs.add(c);
	}
	
	public List<URLConfig> getUrlConfigs() {
		return urlConfigs;
	}
	
	public Iterator<Action> getActions() {
		return actions.iterator();
	}
	
	@Override
	public TransferEngine getEngine(TransferInfo info) throws IOException{
		return new io.downloaders.newdownloader3.NewDownloader3((DLInfo) info, this);
//		return new io.downloaders.SimulatorDownloader((DLInfo) info);
	}

	@Override
	public boolean validLink(String url) {
		if (urlConfigs.isEmpty()){
			return true;
		} else {
			
			for (URLConfig uc:urlConfigs) {
				if (uc.matchesExpression(url)) {
					return true;
				}
			}
			return false;
		}
		
	}

	public void addAction(Action a) {
		actions.add(a);
	}

}
