/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package io;

import io.downloaders.FileDownloader;
import io.downloaders.action.Action;

import java.io.IOException;

import model.DLInfo;
import model.transfer.TransferEngine;
import model.transfer.TransferInfo;
import model.urlconfig.URLConfig;

public class DirectDownloadCfg implements IDownloaderConfig {
	private URLConfig urlCfg;
	
	@Override
	public TransferEngine getEngine(TransferInfo info) throws IOException {
		return new FileDownloader((DLInfo) info);
	}

	@Override
	public boolean validLink(String url) {
		if (urlCfg==null) 
			return true;
		else
			return urlCfg.matchesExpression(url);
	}

	@Override
	public void addUrlConfig(URLConfig urlCfg) {
		this.urlCfg = urlCfg;
	}

	@Override
	public void addAction(Action a) {
	}

}
