/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package io.downloaders;


import java.io.IOException;
import java.nio.file.Files;

import model.DLInfo;
import model.transfer.EngineConfig;
import model.transfer.TransferEngine;


public abstract class Downloader extends TransferEngine  {

	protected DLInfo dlInfo;
	
	public Downloader(DLInfo info,EngineConfig cfg) {
		super(info,cfg);
		this.dlInfo=info;
	}
	
	public DLInfo getDlInfo() {
		return dlInfo;
	}
	
	protected void createOutDirs() throws IOException {
		Files.createDirectories(dlInfo.getOutputFile().getParent());
	}
	
}
