/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package io.downloaders;

import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;

import java.io.IOException;

import model.DLInfo;

public class HTMLDownloader extends Downloader {

	private DLInfo dlInfo;

	private ShoshoneClient urlConn;
	
	
	public HTMLDownloader(DLInfo dlInfo) throws IOException {
		super(dlInfo, null);
		this.dlInfo = dlInfo;
	}

	public void startTransfer() throws IOException, CancelException {
		urlConn=new ShoshoneClient(dlInfo.getUrl(),proxy);
		urlConn.setAutoReferer();
		urlConn.setFollowRedirects(true);
		urlConn.applyGetRequest();
		urlConn.closeConnection();
	}

	public void addRequestParameter(String param,String val) {
		urlConn.addRequestProperty(param, val);
	}

	public String getResponse() throws IOException {
		return urlConn.getResponse();
	}
	
	@Override
	public void updateCurrentBytes() {
		dlInfo.updateBytes(urlConn.getTransferedBytes());
	}
	
	@Override
	public void cancel() {
		urlConn.cancel();
	}

}
