package io.downloaders;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

import net.util.LinkExtractor;
import net.util.LinkExtractorById;

import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;

import model.DLInfo;
import model.transfer.EngineConfig;
import io.downloaders.newdownloader3.NewDownloader3;

public class ImageshackV2Downloader extends NewDownloader3 {

	public ImageshackV2Downloader(DLInfo info, EngineConfig cfg) throws IOException {
		super(info, cfg);
	}

	@Override
	public void startTransfer() throws IOException, CancelException {
		client.setProxy(proxy);
		client.setFollowRedirects(true);
		client.setAutoReferer();
		client.setUrl(dlInfo.getUrl());
		client.applyGetRequest();
		
		String key="class='image'";
		String token="src";
		
		String s=LinkExtractor.preFilterHtml(client.getResponse());
		
		int k=s.indexOf(key);
		
		if (s.indexOf("id='detail-direct'")>-1) {
			client.setUrl(LinkExtractorById.getLinkExtractor().getLink(client.getUrl(), s, new String[]{"detail-direct","value"}));
		} else if (s.indexOf("id='direct-link'")>-1) {
			client.setUrl(LinkExtractorById.getLinkExtractor().getLink(client.getUrl(), s, new String[]{"direct-link","value"}));
		} else {
		
			int i = s.lastIndexOf('<',k);
			
			String t=token+'=';
			int start=s.indexOf(t, i)+t.length()+1;
			int end=s.indexOf(LinkExtractor.delimiter, start);
			
			client.setUrl("http:"+ s.substring(start,end));
		}
		client.applyGetRequest(false);
		if (client.getContentLength()!=-1L && dlInfo.getFileSize()==-1) dlInfo.setFileSize(client.getContentLength());
		if (dlInfo.getFileName()==null)	dlInfo.setFileName(client.getFilename());
		
		createOutDirs();
		Path f=dlInfo.getOutputFile();
		client.readResponseAndSave(f);
		client.closeConnection();
		if (!dlInfo.typeCheckDisabled() && (client.getResponseCode()>=400 || ShoshoneClient.TYPE_HTML.equals(client.getFullContentType()))) {
			System.out.println(toString());
			throw new IOException();
		}
		if (dlInfo.getFileSize()==-1) dlInfo.setFileSize(Files.size(f));
	}
}
