/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package io.downloaders.newdownloader3;

import java.io.IOException;

import net.util.LinkExtractor;

import model.DLInfo;
import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;

public class ConditionalRedirectAction extends RedirectAction{

	private String contains;
	private String[] argsElse;
	
	public ConditionalRedirectAction(LinkExtractor extractor, String contains, String[] extractorArgs,String[] extractorArgsElse) {
		super(extractor, extractorArgs);
		this.contains=contains;
		this.argsElse=extractorArgsElse;
	}

	@Override
	public void apply(ShoshoneClient client, DLInfo info) throws IOException, CancelException {
		client.applyGetRequest();

		String rd;
		if (client.getResponse().contains(contains)) {
			rd=le.getLink(client.getUrl(), client.getResponse(), args);
		} else {
			rd=le.getLink(client.getUrl(), client.getResponse(), argsElse);
		}
		client.setUrl(rd);
	}

}
