/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package io.downloaders.newdownloader3;

import io.downloaders.action.Action;

import java.io.FileNotFoundException;
import java.io.IOException;

import model.DLInfo;

import net.util.LinkExtractor;
import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;

public class RedirectAction extends Action {

	protected LinkExtractor le;
	protected String[] args;
	protected static String errFnF;
	
	public static void setErrFnF(String errFnF) {
		RedirectAction.errFnF = errFnF;
	}
	
	public RedirectAction(LinkExtractor extractor,String[] extractorArgs) {
		this.le=extractor;
		this.args=extractorArgs;
	}

	@Override
	public void apply(ShoshoneClient client,DLInfo info) throws IOException, CancelException {
		client.applyGetRequest();
		String rd=le.getLink(client.getUrl(), client.getResponse(), args);
		if (rd==null) throw new FileNotFoundException(errFnF);
		client.setUrl(rd);
	}

}
