package jbiu.gui;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import jbiu.gui.input.model.GalleryInputComponentConfig;
import jbiu.gui.input.model.InputComponentConfig;
import jbiu.model.ConfigModel;
import jbiu.model.UploaderConfig;


public class GUIUploaderConfig implements Comparable<GUIUploaderConfig> {
	private String display,userDescr,passDescr;
	private List<InputComponentConfig> inputComps;
//	private List<String> inputCompDesc; //,otherLinkDesc;
//	private InputComponentConfig galleryInputComponent;
	
	private GalleryInputComponentConfig galleryInputComponentConfig;
	private List<String> linkTypeNames;
	private String host;
	
	public GUIUploaderConfig(String host) {
		this.host = host;
		userDescr="User";
		passDescr="Password";
	}
	
//	void setGalleryInputComponent(InputComponentConfig galleryInputComponent) {
//		this.galleryInputComponent = galleryInputComponent;
//	}
//	
//	public InputComponentConfig getGalleryInputComponent() {
//		return galleryInputComponent;
//	}
	
	void setDisplay(String display) {
		this.display = display;
	}
	
	@Override
	public String toString() {
		return display;
	}
	
	
	public UploaderConfig getUploaderConfig() {
		return ConfigModel.getUploaderConfig(host);
	}
	
	void add(InputComponentConfig comp) {
		if (inputComps==null) inputComps=new LinkedList<>();
		inputComps.add(comp);
	}
	
	public Iterator<InputComponentConfig> getInputComponentsIterator() {
		return inputComps.iterator();
	}
	
	public int getInputComponentCount() {
		if (inputComps==null) 
			return 0;
		else
			return inputComps.size();
	}

//	void addInputComponentDescription(String desc) {
//		if (inputCompDesc==null) inputCompDesc=new LinkedList<String>();
//		inputCompDesc.add(desc);
//	}
	
//	public Iterator<String> getInputComponentDescIterator() {
//		return inputCompDesc.iterator();
//	}

	/*void setViewLinkDescription(String desc) {
		viewLinkDescription=desc;
	}

	public void addOtherLinkDescription(String desc) {
		if (otherLinkDesc==null) otherLinkDesc=new LinkedList<String>();
		otherLinkDesc.add(desc);
	}
	
	public String getViewLinkDescription() {
		return viewLinkDescription;
	}
	
	public Iterator<String> getOtherLinkDescriptions() {
		return otherLinkDesc.iterator();
	}*/
	
	void setGalleryInputComponentConfig(GalleryInputComponentConfig galleryInputComponentConfig) {
		this.galleryInputComponentConfig = galleryInputComponentConfig;
	}
	
	public GalleryInputComponentConfig getGalleryInputComponentConfig() {
		return galleryInputComponentConfig;
	}

	public String getUserDescription() {
		return userDescr;
	}
	
	void setUserDescription(String userDescr) {
		this.userDescr = userDescr;
	}

	public String getPassDescription() {
		return passDescr;
	}
	
	void setPassDescription(String passDescr) {
		this.passDescr = passDescr;
	}
	
	public Iterator<String> getLinkTypeNames() {
		return linkTypeNames.iterator();
	}
	
	void addLinkTypeName(String name) {
		if (linkTypeNames == null) 
			linkTypeNames=new LinkedList<>();
		linkTypeNames.add(name);
	}

	@Override
	public int compareTo(GUIUploaderConfig o) {
		return display.compareToIgnoreCase(o.display);
	}
	
	public String getInternalName() {
		return host;
	}

	public boolean hasGallery() {
		return galleryInputComponentConfig!=null;
	}
	
}
