package jbiu.gui;

import gui.util.GuiUtil;

import java.awt.BorderLayout;
import java.awt.Desktop;
import java.awt.Dialog;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextPane;

import jbiu.model.UploaderConfig;

public class HosterInfoDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private JTextPane rules;
	
	private JLabel maxSize,types;
	private JPanel pRules,pMax,pTypes;
	
	private UploaderConfig cfg;
	private JButton close,copyUrl;
	
	private MouseListener ml;
	
	public HosterInfoDialog() {
		super((Dialog)null,"Hoster info",true);
		
		JPanel p=new JPanel();
		p.setLayout(new GridLayout(3, 1)  );
		setLayout(new BorderLayout());
		
		rules=new JTextPane();
		rules.setEditable(false);
		rules.setOpaque(true);
		rules.setBorder(BorderFactory.createLoweredBevelBorder());
		rules.setBackground(p.getBackground());
		
		copyUrl=new JButton("Copy");
		
		copyUrl.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				GuiUtil.setClipboardString(cfg.getRulesUrl());				
			}
		});
		
		close=new JButton("Close") ;
		maxSize=new JLabel();
		types=new JLabel();
		
		pRules=new JPanel(); 
		pMax=new JPanel(); 
		pTypes=new JPanel();
		
		pRules.setBorder(BorderFactory.createTitledBorder("Site's uploading rules"));
		
		pRules.add(rules);
		pRules.add(copyUrl);
		
		pMax.setBorder(BorderFactory.createTitledBorder("Max. allowed file size"));
		pMax.add(maxSize);
		
		pTypes.setBorder(BorderFactory.createTitledBorder("Allowed image types"));
		pTypes.add(types);
		
		
		p.add(pRules);
		p.add(pMax);
		p.add(pTypes);
		add(p,BorderLayout.CENTER);
		add(close,BorderLayout.SOUTH);
		setSize(450, 300);
	}

	public void showDialog(final UploaderConfig cfg) {
		this.cfg=cfg;
		if (cfg.getMaxFileSize()>0) {
			maxSize.setText(Integer.toString(cfg.getMaxFileSize()) + " Bytes / "+GuiUtil.formatBytes(cfg.getMaxFileSize()));
		} else {
			maxSize.setText("n/a");
		}
		types.setText(cfg.getAllowedFileTypes().toString());
		
		rules.setContentType( "text/html" );
		rules.setText(  "<html><u>"+cfg.getRulesUrl()+"</u></html>");
		
		
		rules.removeMouseListener(ml);
		ml=new MouseAdapter() {
		 
			
			@Override
			public void mousePressed(MouseEvent e) {
				try {
					String url = cfg.getRulesUrl();
					Desktop.getDesktop().browse(new URI(url));
				} catch (IOException ioex) {
				} catch (URISyntaxException ex) {
				}				
			}
		};
		rules.addMouseListener(ml);
		
		setVisible(true);
	}
	
}
