package jbiu.gui;

import gui.okcancelpanel.ClosePanel;
import gui.settings.SettingCheckBox;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Collection;

import gui.util.GuiUtil;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JPanel;


import jbiu.model.UploaderConfig;
import static jbiu.init.JBIU.rm;

public class LinkCollectorGUI extends JFrame {

	private JComboBox<GUIUploaderConfig> cbHosters;
	private DefaultComboBoxModel<GUIUploaderConfig> cbModel;
	private LinkCollectorPanel linkPanel;
	
	private static LinkCollectorGUI instance;
	
	public static LinkCollectorGUI getInstance() {
		if (instance==null) instance=new LinkCollectorGUI(GUIConfigLoader2.getConfigs());
		return instance;
	}
	
	private LinkCollectorGUI(Collection<GUIUploaderConfig> cfgs) {
		super("Image links");
		
		
		cbModel=new DefaultComboBoxModel<>();
		cbHosters=new JComboBox<>(cbModel);
		Container cp=getContentPane();
		cp.setLayout(new BorderLayout());

		cbModel.addElement(GUIConfigLoader2.getSimulator());
		for (GUIUploaderConfig cfg: cfgs) {
			cbModel.addElement(cfg);
		}
		
		cbHosters.addItemListener(new ItemListener() {
			
			@Override
			public void itemStateChanged(ItemEvent e) {
				if (e.getStateChange()==ItemEvent.SELECTED) {
					displayLinks(GuiUtil.getSelectedValue(cbHosters));
				}
				
			}
		});
		JPanel cbHostersPanel=new JPanel();
		cbHostersPanel.add(cbHosters);
		linkPanel = new LinkCollectorPanel();
		ClosePanel closePanel=new ClosePanel(this,rm().getLocalizedString( "close"));
		
		cp.add(cbHostersPanel,BorderLayout.NORTH);
		cp.add(linkPanel,BorderLayout.CENTER);
		cp.add(closePanel,BorderLayout.SOUTH);
		
		((FlowLayout) closePanel.getLayout()).setHgap(20);
		final SettingCheckBox chkClear=new SettingCheckBox(rm().getLocalizedString( "clearOnClose"),"clearLinksOnClose");
		closePanel.add(chkClear);
		closePanel.getCloseButton().addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				if (chkClear.isSelected()) {
					linkPanel.clear();
				}
			}
		});
		
		setSize(640, 480);
	}

	private static final long serialVersionUID = 1L;

	private void displayLinks(GUIUploaderConfig gcfg) {
		UploaderConfig cfg=gcfg.getUploaderConfig();
		System.out.println(cfg.getLinkCollector());
		linkPanel.displayLinks(cfg.getLinkCollector(),gcfg.getLinkTypeNames(),  cfg.getLinkTypeCount(),null);
	}
	
	public void showDialog(){
		showDialog(GuiUtil.getSelectedValue(cbHosters));
	}
	
	public void showDialog(GUIUploaderConfig select){
		if (!isShowing()){
			displayLinks(select);
			super.setVisible(true);
		}
	}
}
