package jbiu.gui.gallery;


import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import util.exception.CancelException;

import jbiu.model.UploaderConfig;
import jbiu.model.gallery.ExistingGallery;

public class ExistingGalleryOption extends GalleryOption {

	protected ExistingGallery eg;
	protected static List<String> tokenNames;
	protected static Map<String, String> additionalTokens;
	
	public ExistingGalleryOption(String display,ExistingGallery eg) {
		super(display);
		this.eg=eg;
	}

	public static void setTokenNames(List<String> tokenNames) {
		ExistingGalleryOption.tokenNames = tokenNames;
	}
	
	@Override
	public Map<String, String> getTokens(UploaderConfig cfg) throws IOException, CancelException {
		Iterator<String> it=tokenNames.iterator();
		int i=0;
		while(it.hasNext()) {
			super.setToken(it.next(), eg.getValues()[i++]);
		}
		if (additionalTokens!=null) {
			for (String tokenName:additionalTokens.keySet()) {
				super.setToken(tokenName, additionalTokens.get(tokenName));
			}
		}
		return tokens;
	}

	public static void putAdditionalToken(String name, String value) {
		if (additionalTokens==null) additionalTokens=new HashMap<String, String>();
		additionalTokens.put(name, value);
	}

}
