package jbiu.gui.gallery;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import util.exception.CancelException;

import jbiu.model.UploaderConfig;

public abstract class GalleryOption {
	protected Map<String, String> tokens;
	
	private String display;
	
	public GalleryOption(String display) {
		tokens=new HashMap<String, String>();
		this.display=display;
	}

	@Override
	public GalleryOption clone() throws CloneNotSupportedException {
		GalleryOption go=(GalleryOption)super.clone();
		Map<String, String> tokensCopy=new HashMap<String, String>();
		for (String s:tokens.keySet()) {
			tokensCopy.put(new String(s), new String(tokens.get(s)));
		}
		
		go.tokens=tokensCopy;
		go.display=new String(display);
		return go;
	}
	
	public void setToken(String name,String value) {
		tokens.put(name, value);
	}
	
//	public Map<String, String> getTokens() throws IOException {
//		return tokens;
//	}
	
	public abstract Map<String, String> getTokens(UploaderConfig cfg) throws IOException, CancelException; 
	
	public String toString() {
		return display;
	}
}
