package jbiu.gui.gallery;

import gui.layout.PercentageLayout;
import gui.okcancelpanel.OKCancelPanel;
import gui.util.GuiUtil;

import java.awt.BorderLayout;
import java.awt.Window;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import jbiu.gui.input.InputComponent;
import jbiu.gui.input.model.InputComponentConfig;

import util.exception.CancelException;

import static jbiu.init.JBIU.rm;

public class NewGalleryGUI extends JDialog {

	private static final long serialVersionUID = 1L;
	
	public NewGalleryGUI() {
		super((Window)null, "Create gallery", ModalityType.APPLICATION_MODAL);
		setSize(300, 200);
		
	}
	
	public Map<String, String> show(NewGalleryOption opt) throws CancelException {
		Map<String, String> tokens=new HashMap<String, String>();
		Iterator<InputComponentConfig> itComp=  opt.getCompIterator();
		Iterator<String> itDesc = opt.getDescIterator();
		JPanel cp=(JPanel) getContentPane();
		JPanel pComp=new JPanel();
		pComp.setLayout(new PercentageLayout());
		ArrayList<InputComponent> components=new ArrayList<>();
		int y=0;
		while (itComp.hasNext() && itDesc.hasNext()) {
			InputComponent comp=(InputComponent) itComp.next().createInputComponent();
			components.add(comp);
			pComp.add(new JLabel(itDesc.next()),PercentageLayout.constraints(5, y, 45, 24, false, true, false, true));
			pComp.add(comp,PercentageLayout.constraints(50, y, 45, 24, false, true, false, true));
			y+=24;			
		}
		OKCancelPanel okCancelPanel=new OKCancelPanel(this, rm().getLocalizedString("ok"), rm().getLocalizedString("cancel"));
		cp.add(pComp,BorderLayout.CENTER);
		cp.add(okCancelPanel,BorderLayout.SOUTH);
		
		GuiUtil.centerWindow(this);
		
		setVisible(true);
		okCancelPanel.getRetVal();
		
		for (InputComponent comp:components){
			tokens.put(comp.getTokenName(), comp.getTokenValue());
		}
					
		return tokens;
	}
	
}
