package jbiu.gui.gallery;


import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import util.exception.CancelException;

import jbiu.gui.input.model.InputComponentConfig;
import jbiu.io.gallery.GalleryLoader;
import jbiu.model.UploaderConfig;
import jbiu.model.gallery.ExistingGallery;


public class NewGalleryOption extends ExistingGalleryOption {

	private List<InputComponentConfig> inputConfigs;
	private List<String> descs;
	
	public NewGalleryOption(String display) {
		super(display,null);
		inputConfigs=new ArrayList<>();
		descs=new ArrayList<>();
	}
	
	public void addInputComponent(String desc,InputComponentConfig cfg) {
		inputConfigs.add(cfg);
		descs.add(desc);
	}
	
//	public void addDescription(String desc ) {
//		descs.add(desc);
//	}
	
	public Iterator<InputComponentConfig> getCompIterator() {
		return inputConfigs.iterator();
	}
	
	public Iterator<String> getDescIterator() {
		return descs.iterator();
	}
	
	@Override
	public Map<String, String> getTokens(UploaderConfig cfg) throws IOException, CancelException {
		Map<String, String> inputTokens= new NewGalleryGUI().show(this);
		for (String s:inputTokens.keySet()) {
			super.setToken(s, inputTokens.get(s));
		}
		if (cfg.getGalleryConfig().getCreateUrl()!=null) {
			ExistingGallery eg= GalleryLoader.createNewGallery(cfg,inputTokens,GalleryLoader.loadExistingGalleries(cfg));
			Iterator<String> it=tokenNames.iterator();
			int i=0;
			while(it.hasNext()) {
				super.setToken(it.next(), eg.getValues()[i++]);
			}
			
		}
		return tokens;
	}
}
