package jbiu.gui.input;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;


public class AssociatedTextInputComponent extends AssociatedInputComponent {

	private static final long serialVersionUID = 1953405299750169282L;
	
	
	public static final String FILE_TOKEN = "$filename$";
	public static final String FILE_TOKEN_REGEX = "\\$filename\\$";
	public static final String COUNTER_TOKEN="$counter;start=";
	
	public AssociatedTextInputComponent(TextInputComponent inputComponent) {
		super(inputComponent);
	}

	@Override
	public void applyToAssociated() {
		String s=getTokenValue();
		int counter=-1;
		
		int cInd=s.indexOf(COUNTER_TOKEN);
		int cIndStart=cInd+COUNTER_TOKEN.length();
		int cIndEnd=s.indexOf('$', cIndStart);
		if (cInd>-1) {
			counter=Integer.parseInt(s.substring(cIndStart, cIndEnd));
		}
		
		for (InputComponent tic:associated) {
			
			String token=getTokenValue();
			if (cInd>-1) {
				token = token.substring(0, cInd) + counter + token.substring(cIndEnd+1);
			}
			tic.setTokenValue(token.replaceAll(FILE_TOKEN_REGEX, tic.getFile().getFileName().toString()));
			counter++;
		}
	}

	
	@Override
	public boolean hasMultipleTokens() {
		return false;
	}

	private void appendText(String s) {
		JTextField txtInput=(JTextField) wrappedInputComponent.comp;
		txtInput.setText(txtInput.getText()+s);
	}
	
	@Override
	public void setApplyListener() {

		JButton bApply=new JButton("Apply");
		add(bApply,BorderLayout.EAST);
		bApply.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				applyToAssociated();				
			}
		});
		
		final JPopupMenu popupFunc=new JPopupMenu();
		JMenuItem menuCounter=new JMenuItem("Counter");
		popupFunc.add(menuCounter);
		menuCounter.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				appendText(COUNTER_TOKEN+"1$");				
			}
		});
		
		JMenuItem menuFilename=new JMenuItem("Filename");
		popupFunc.add(menuFilename);
		menuFilename.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				appendText(FILE_TOKEN);				
			}
		});
		JTextField txtInput=(JTextField) wrappedInputComponent.comp;
		txtInput.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				if (e.isPopupTrigger()) showPopup(e);
			}
			
			@Override
			public void mouseReleased(MouseEvent e) {
				if (e.isPopupTrigger()) showPopup(e);
			}
			
			private void showPopup(MouseEvent e) {
				popupFunc.show(e.getComponent(), e.getX(), e.getY());
			}
		});
	}

}
