package jbiu.gui.input;

import gui.util.combobox.ComboBoxValue;
import gui.util.combobox.VComboBox;
import gui.util.combobox.VComboBoxModel;

import java.util.Iterator;
import java.util.Map;

import jbiu.gui.input.model.ComboBoxInputComponentConfig;

	
public class ComboboxInputComponent extends InputComponent  {
	private static final long serialVersionUID = 1L;

	private VComboBoxModel<String> cbModel;

	private VComboBox cb;
	
	public ComboboxInputComponent(ComboBoxInputComponentConfig inputComponentConfig) {
		super(new VComboBox(),inputComponentConfig);
		cbModel=new VComboBoxModel<String>();
		for (Iterator<ComboBoxValue<String>> it= inputComponentConfig.getValues();it.hasNext();){
			cbModel.addElement(it.next());
		}
		
		cb=(VComboBox)comp;
		cb.setModel(cbModel);
	}

	@Override
	public String getTokenValue() {
		return cbModel.getSelectedValue();
	}

	@Override
	public void setTokenValue(String v) {
		cbModel.setSelectedItemByValue(v);
	}

	@Override
	public Map<String, String> getMultipleTokens() {
		return null;
	}

	@Override
	public boolean hasMultipleTokens() {
		return false;
	}


	public void addElement(String display,String value) {
		cbModel.addElement(display, value);
	}
	
}
