package jbiu.gui.input;

import java.awt.BorderLayout;
import java.nio.file.Path;

import javax.swing.JComponent;

import jbiu.gui.input.model.InputComponentConfig;

public abstract class InputComponent extends JComponent implements IInputComponent {
	private static final long serialVersionUID = 1L;
	protected JComponent comp;
	private InputComponentConfig inputCfg;
	private Path file;
	
	public InputComponent(InputComponentConfig inputCfg ) {
		this(null,inputCfg);
	}
	
	public InputComponent(JComponent comp,InputComponentConfig inputCfg) {
		setLayout(new BorderLayout());
		if (comp!=null) setComp(comp);
		this.inputCfg=inputCfg;
	}
	
	protected void setComp(JComponent comp) {
		this.comp = comp;
		add(comp,BorderLayout.CENTER);
	}
	
	//public abstract void setArgs(List<String[]> args) ;
	

	
	public String getTokenName() {
		return inputCfg.getTokenName();
	}
	
	protected InputComponentConfig getInputCfg() {
		return inputCfg;
	}
	
	protected void setInputCfg(InputComponentConfig inputCfg) {
		this.inputCfg = inputCfg;
	}
	
	public abstract boolean hasMultipleTokens() ;
	
	public String getDescription() {
		return inputCfg.getDescription();
	}
	

	public void setFile(Path file) {
		this.file = file;
	}

	protected Path getFile() {
		return file;
	}
}
