package jbiu.gui.input.model;

import gui.util.combobox.ComboBoxValue;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import jbiu.gui.input.AssociatedComboboxInputComponent;
import jbiu.gui.input.ComboboxInputComponent;
import jbiu.gui.input.IInputComponent;
import jbiu.gui.input.InputComponent;

public class ComboBoxInputComponentConfig extends InputComponentConfig{
	private List<ComboBoxValue<String>> values; 
		
	public ComboBoxInputComponentConfig(String tokenName, String description) {
		super(tokenName, description);
		values=new LinkedList<>();
	}


	public void addElement(String display, String value) {
		values.add(new ComboBoxValue<String>(display, value));
	}

	@Override
	public InputComponent createInputComponent() {
		return new ComboboxInputComponent(this);
	}

	public Iterator<ComboBoxValue<String>> getValues() {
		return values.iterator();
	}

	@Override
	public IInputComponent createAssociatedInputComponent() {
		return new AssociatedComboboxInputComponent((ComboboxInputComponent) createInputComponent());
	}

}
