package jbiu.gui.input.model;

import jbiu.gui.GUIUploaderConfig;
import jbiu.gui.gallery.NewGalleryOption;
import jbiu.gui.gallery.NoGalleryOption;
import jbiu.gui.input.GalleryInputComponent;
import jbiu.gui.input.IInputComponent;

import static jbiu.init.JBIU.rm;

public class GalleryInputComponentConfig extends InputComponentConfig{

	private NoGalleryOption noGalleryOption;
	private NewGalleryOption newGalleryOption;
	private GUIUploaderConfig cfg;
	
	public GalleryInputComponentConfig(GUIUploaderConfig cfg, String description) {
		super(null, description);
		this.cfg=cfg;
	}
	
	public NewGalleryOption getNewGalleryOption() {
		return newGalleryOption;
	}
	
	public NoGalleryOption getNoGalleryOption() {
		return noGalleryOption;
	}

	public NoGalleryOption createNoGalleryOption() {
		if (noGalleryOption==null) {
			noGalleryOption=new NoGalleryOption(rm().getLocalizedString("noGallery"));
			return noGalleryOption;
		} else {
			throw new IllegalStateException();
		}
	}
	
	public NewGalleryOption createNewGalleryOption() {
		if (newGalleryOption==null){
			newGalleryOption=new NewGalleryOption(rm().getLocalizedString("newGallery"));
			return newGalleryOption;
		} else {
			throw new IllegalStateException();
		}
	}
	
	
	@Override
	public IInputComponent createInputComponent() {
		return new GalleryInputComponent(cfg);
	}

	@Override
	public IInputComponent createAssociatedInputComponent() {
		return null;
	}

}
