package jbiu.gui.settings;

import static jbiu.init.JBIU.LOCALE_LINK_TOKEN;
import static jbiu.init.JBIU.LOCALE_VIEW_LINK_TOKEN;
import static jbiu.init.JBIU.rm;
import gui.layout.percent2.APConstraint;
import gui.layout.percent2.AnchorPercentLayout;
import gui.settings.dialog.component.SingleSettingsComponent;

import java.awt.Component;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;

import jbiu.init.JBIU;
import jbiu.model.template.LinkTemplate;
import settings.Settings;

public class ModifiersSettingsComponent extends SingleSettingsComponent {

	private JPanel panel;
	private JComboBox<LinkTemplate> cbMod;
	private DefaultComboBoxModel<LinkTemplate> cbModel;
	private JButton bAdd,bRemove;
	private JTextField txtNewVal,txtNewDisp;
	
	public ModifiersSettingsComponent() {
		super(JBIU.SETTING_MODIFIERS);
		cbMod=new JComboBox<>();
		cbModel=(DefaultComboBoxModel<LinkTemplate>) cbMod.getModel();
		bAdd=new JButton("+");
		bRemove =new JButton("-");
		txtNewVal=new JTextField();
		txtNewDisp=new JTextField();
		
		txtNewVal.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				showPopup(e);
			}
			
			@Override
			public void mouseReleased(MouseEvent e) {
				showPopup(e);
			}
		});
		
		bAdd.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				
				cbModel.addElement(new LinkTemplate(txtNewDisp.getText(), txtNewVal.getText()));
				String empty="";
				txtNewDisp.setText(empty);
				txtNewVal.setText(empty);
			}
		});
		
		bRemove.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				cbModel.removeElementAt(cbMod.getSelectedIndex());
			}
		});
		panel=new JPanel();
		panel.setLayout(new AnchorPercentLayout());
		
		JPanel p=new JPanel(new GridLayout(2, 2));
		p.add(new JLabel("Description"));
		p.add(new JLabel("Expression"));
		p.add(txtNewDisp);
		p.add(txtNewVal);
		panel.add(p,APConstraint.constraint().left(0).top(0).right(60).height(48));
		panel.add(cbMod,APConstraint.constraint().left(0).bottom(0).height(24).right(60));
		panel.add(bAdd,APConstraint.constraint().right(0).bottom(24).height(24).width(60));
		panel.add(bRemove,APConstraint.constraint().right(0).bottom(0).height(24).width(60));
	}

	private void insert(String insert) {
		String s=txtNewVal.getText();
		int i=txtNewVal.getCaretPosition();
		if (s.isEmpty()) {
			txtNewVal.setText(insert);
		} else {
			txtNewVal.setText(s.substring(0,i)+insert +s.substring(i));
		}
	}
	
	private void showPopup(MouseEvent e) {
		if (e.isPopupTrigger()) {
			JPopupMenu pm= new JPopupMenu();
			JMenuItem mInsertLinkToken=new JMenuItem(rm().getLocalizedString(LOCALE_LINK_TOKEN));
			JMenuItem mInsertViewLinkToken=new JMenuItem(rm().getLocalizedString(LOCALE_VIEW_LINK_TOKEN));
			mInsertLinkToken.addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent e) {
					insert("$LINK$");
				}
			});
			mInsertViewLinkToken.addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent e) {
					insert("$VIEWLINK$");
				}
			});
			pm.add(mInsertLinkToken);
			pm.add(mInsertViewLinkToken);
			pm.show(e.getComponent(), e.getX(), e.getY());
		}
	}
	
	@Override
	public void saveSettings(Settings s) {
		String[] modifiers=new String[cbModel.getSize()];
		for (int i=0;i<cbModel.getSize();i++) {
			LinkTemplate m=cbModel.getElementAt(i);
			modifiers[i] =m.getValue1()+"#"+m.getValue2(); 
		}
		s.set(settingsName, modifiers);
	}

	@Override
	public void loadSettings(Settings s) {
		String[] modifiers=s.getStringArray(settingsName);
		for (String m:modifiers) {
			String[] t=m.split("#");
			cbModel.addElement(new LinkTemplate(t[0], t[1]));
		}
	}

	@Override
	public Component getComponent() {
		return panel;
	}
	
}