package jbiu.init;

import gui.resource.ResourceManager;

import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

import net.util.ProxySettings;

import util.exception.CancelException;

import model.transfer.Status;
import core.io.Application;

import jbiu.io.login.LoginManager;
import jbiu.model.ConfigModel;
import jbiu.model.JBIUModel;
import jbiu.model.ScheduledUploadManager;
import jbiu.model.UploadManager;
import jbiu.model.template.LinkTemplate;


public class JBIU extends Application {
	
	private static JBIU instance;
	
	public static JBIU getInstance() {
		return instance;
	}
	
	public static ResourceManager rm() {
		return instance.rm;
	}
	
	public JBIU(String subDir,String settingsFile) throws IOException {
		super(subDir, settingsFile, true);
		JBIUModel.init(settings,new ScheduledUploadManager(settings.getInt(SETTING_THREADS),ProxySettings.getProxySettings(settings)), loadModifiers());
		instance=this;
		Status.queued.setDispName(rm().getLocalizedString("statusQueued"));
		Status.loading.setDispName(rm().getLocalizedString("statusLoading"));
		Status.finished.setDispName(rm().getLocalizedString("statusFinished"));
		Status.stopped.setDispName(rm().getLocalizedString("statusStopped")); 
		Status.remove.setDispName("removing");
	}

	public static final String 	SETTING_THREADS="maxThreads",
			SETTING_TIMEOUT="timeout",
			SETTING_MODIFIERS="modifiers",
			SETTING_LOOK_AND_FEEL = "lookAndFeel",
			SETTING_WIDTH="windowWidth",
			SETTING_HEIGHT="windowHeight",
			SETTING_X="windowX",
			SETTING_Y="windowY",
			SETTING_TRIES="maxTries",
			SETTING_LAST_PATH="lastPath",
			SETTING_LAST_PATH_SAVE_LINKS="lastPathSaveLinks"
			;

	public static final String 	LOCALE_PROXY_ENABLED ="settingProxyEnabled",
		   	LOCALE_PROXY_HOST="settingProxyHost",
		   	LOCALE_PROXY_PORT="settingProxyPort",
		   	LOCALE_TIMEOUT="settingTimeout",
		   	LOCALE_LINK_TOKEN="settingLinkToken",
		   	LOCALE_VIEW_LINK_TOKEN="settingViewLinkToken",
		   	LOCALE_EMPTY_NODE = "emptyNode"
		   	;


	
	
	public void save(UploadManager um) throws IOException, CancelException {
//		BufferedWriter bw=new BufferedWriter(new FileWriter(new File(execPath+"session")));
//		
//		Collection<TransferInfo> transferInfos= um.getUnfinished();
//		
//		for (TransferInfo ti:transferInfos) {
//			ULInfo ulInfo=(ULInfo)ti;
//			bw.write(ulInfo.getFile().getAbsolutePath());
//			bw.write('\n');
//		}
//		bw.close();
//		
//		settings.saveSettings();
		LoginManager.performLogout(ConfigModel.getAllConfigs());
	}
	
	public List<LinkTemplate> loadModifiers() {
		LinkedList<LinkTemplate> mods=new LinkedList<>();
		String[] modifiers=settings.getStringArray(SETTING_MODIFIERS);
		for (String m:modifiers) {
			String[] t=m.split("#");
			mods.add(new LinkTemplate(t[0], t[1]));
		}
		return mods;
	}

	@Override
	public String getVersion() {
		return "2.3";
	}
}
