package jbiu.io.account;


import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import util.base64.Base64Decoder;
import util.base64.Base64Encoder;

import core.io.Application;

import jbiu.init.JBIU;
import jbiu.model.security.AES;
import jbiu.model.security.MD5;


public class AccountManager {
	
	private static byte[] superPassword=null;
	
	private static Map <String,RawAccountData> rawData=new Hashtable<String, RawAccountData>();;
	
	
	public static void loadRawData(String hosterName) {
		if (hosterName!=null) {
			Path p = getAccountFile(hosterName);
			try {
				if (Files.exists(p)) {
					List<String> accData= Files.readAllLines(p,Application.UTF8);
					Iterator<String> it=accData.iterator();
					if (it.hasNext()) {
						String user=it.next();
						byte[] pass=null,md5=null;
						
						if (it.hasNext()) 
							pass=Base64Decoder.decode(it.next());
						
						if (it.hasNext())
							md5=Base64Decoder.decode(it.next());
						
						RawAccountData l=new RawAccountData(user);
						l.setRawPassword(pass,md5);
						rawData.put(hosterName, l);
					}
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		/*try {
			File f=new File(getFilename(hosterName, ".usr"));
			
			if (f.exists()) {
				BufferedReader br=new BufferedReader(new FileReader(f));
				String usr=br.readLine();
				
				if (usr==null) return;
				File f2=new File(getFilename(hosterName, ".pwd"));
				RawAccountData l=new RawAccountData(usr);
				
				if (f2.exists()) {
					FileInputStream fis=new FileInputStream(f2);
					byte[] buffer=new byte[128];
					int r=fis.read(buffer);
					byte[] pwd=new byte[r];
					System.arraycopy(buffer,0 , pwd, 0, r);
					fis=new FileInputStream(new File(getFilename(hosterName, ".pwd.md5")));
					r=fis.read(buffer);
					byte[] md5=new byte[r];
					System.arraycopy(buffer,0 , md5, 0, r);
					l.setRawPassword(pwd,md5);
				}
				
				rawData.put(hosterName, l);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}*/
	}
	
	public static void saveToFile(String host,String user,byte[] pass,byte[] md5) throws IOException {
		Path p=getAccountFile(host);
		BufferedOutputStream out=new BufferedOutputStream(Files.newOutputStream(p, Application.DEFAULT_WRITE_OPTIONS));
		writeln(out, user);
		if (pass!=null) {
			writeln(out, Base64Encoder.encode(pass) );
			writeln(out, Base64Encoder.encode(md5) );
		}
		out.close();
	}
	
	private static void writeln(OutputStream out,String s) throws IOException {
		out.write( s.getBytes(Application.UTF8 ));
		out.write('\n');
	}
	
	public static void setSuperPassword(byte[] superPassword) {
		AccountManager.superPassword=superPassword;
	}
	

	public static void setLogin(String hoster,String user,byte[] pass) {
		byte[][] pw=AES.encrypt(pass, buildSuperPassword(hoster));
		rawData.put(hoster, new RawAccountData(user,pw[1],pw[0]));
	}
	
	public static void setAndSaveLogin(String hoster,String user,byte[] pass) throws IOException {
//		try {
			
		if (user!=null && !user.equals("")) {
			RawAccountData currentLogin=rawData.get(hoster);
			if (currentLogin==null) {
				currentLogin=new RawAccountData(user);
				rawData.put(hoster, currentLogin);
			}
			byte[] pwd=null,md5=null;
			if (pass!=null) {
				
				byte[][] bytes = AES.encrypt(pass, buildSuperPassword(hoster));
				pwd=bytes[1];
				md5=bytes[0];
				currentLogin.setRawPassword(pwd, md5);
				
			}
			saveToFile(hoster, user, pwd,md5 );
		} else {
			if (rawData.remove(hoster)!=null) {
				Path p=getAccountFile(hoster);
				if (Files.exists(p)) Files.delete(p);
			}
		}
				
				
					
				/*RawAccountData l=null;
				RawAccountData currentLogin=rawData.get(hoster);
				if (currentLogin==null) {
					l=new RawAccountData(user);
					writeUser(user, getFilename(hoster, ".usr"));
				} else if (!user.equals(currentLogin.getUser())) {
					currentLogin.setUser(user);
					writeUser(user, getFilename(hoster, ".usr"));
				}
				
				
				if (pass!=null) {
					if (!pass.equals("")) {
						byte[][] bytes = AES.encrypt(pass, buildSuperPassword(hoster));
						
						if (currentLogin==null) {
							l.setRawPassword(bytes[1], bytes[0]);
							
							saveMD5(bytes[0],getFilename(hoster,".pwd.md5"));
							savePassword(bytes[1], getFilename(hoster, ".pwd"));
						} else if (!Arrays.equals(bytes[0], currentLogin.getPwdMD5())) {
							
							currentLogin.setRawPassword(bytes[1], bytes[0]);
							saveMD5(bytes[0],getFilename(hoster,".pwd.md5"));
							savePassword(bytes[1], getFilename(hoster, ".pwd"));
						}
						
					}
				}
				
				if (l!=null) {
					rawData.put(hoster, l);
				}*/
			
			
			
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
	}

	private static byte[] buildSuperPassword(String hoster) {
		
		byte[] b=new byte[hoster.length()+superPassword.length];
		System.arraycopy(hoster.getBytes(), 0, b, 0, hoster.length());
		System.arraycopy(superPassword, 0, b, hoster.length(), superPassword.length);
		return MD5.getMD5(b);
	}
	
//	private static void writeUser(String user,String filename) throws IOException {
//		
//		File f=new File(filename);
//		f.getParentFile().mkdir();
//		FileWriter fw=new FileWriter(f);
//		fw.write(user);
//		
//		fw.flush();
//		fw.close();
//	}
	
									 // bytes are encrypted
//	private static void savePassword(byte[] bytes,String filename) throws IOException {
//		FileOutputStream fw = new FileOutputStream(new File(filename));;
//		fw = new FileOutputStream(new File(filename));
//		fw.write(bytes);
//		fw.flush();
//		fw.close();
//	}
//	
//	public static void saveMD5(byte[] md5,String filename) throws IOException {
//		FileOutputStream fw = new FileOutputStream(new File(filename));
//		fw.write(md5);
//		fw.flush();
//		fw.close();
//	}
	
//	private static String getFilename(String hoster,String s) {
//		return JBIU.getInstance().getConfigurationPath() + hoster + s;
//	}
	
	private static Path getAccountFile(String host) {
		return JBIU.getInstance().getConfigurationPath().resolve("accounts").resolve(host+".logindata");
	}
		
	public static String getUser(String hosterName) {
		RawAccountData l=rawData.get(hosterName);
		
		if (l==null) {
			loadRawData(hosterName);
			l=rawData.get(hosterName);
			
			if (l==null) return null;
		}
		
		return l.getUser();
	}
	
	public static byte[] getPassword(String hosterName) {
		RawAccountData l=rawData.get(hosterName);
		
		if (l==null) return null;
		
		byte[] rawPassword=l.getRawPassword();
		
		if (rawPassword==null) {
			return null;
		} else {
			return AES.decrypt(rawPassword, buildSuperPassword(hosterName),l.getPwdMD5());
		}
	}
	


}
