package jbiu.io.gallery;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import model.transfer.TransferEngine;

import jbiu.io.login.LoginManager;
import jbiu.model.GalleryConfig;
import jbiu.model.TokenManager;
import jbiu.model.UploaderConfig;
import jbiu.model.gallery.ExistingGallery;

import shoshone.httpclient.PostParameter;
import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;

public class GalleryLoader {
	
	
	public static List<ExistingGallery> loadExistingGalleries(UploaderConfig cfg) throws IOException, CancelException {
		ShoshoneClient client=new ShoshoneClient(null,TransferEngine.getProxy());
		LoginManager.performLogin(client, cfg);
		client.setAutoReferer();
		client.setFollowRedirects(true);
		client.addCookies(cfg.getCookies());
		GalleryConfig gcfg=cfg.getGalleryConfig();
		
		client.setUrl(gcfg.getListUrl());
		client.applyGetRequest();
		String html=client.getResponse();
		List<ExistingGallery> eg= gcfg.getParser().getExistingGalleries(html);
		return eg;
	}		
	
	public static ExistingGallery createNewGallery(UploaderConfig cfg,Map<String, String> inputTokens,List<ExistingGallery> currentGalleries) throws IOException, CancelException {
		ShoshoneClient client=new ShoshoneClient();
		LoginManager.performLogin(client, cfg);
		client.setAutoReferer();
		client.setFollowRedirects(true);
		client.addCookies(cfg.getCookies());
		GalleryConfig gcfg=cfg.getGalleryConfig();
		client.setUrl(TokenManager.resolveUrl(gcfg.getCreateUrl(),inputTokens));
		
		if (gcfg.getCreatePostParameters()!=null) {
			List<PostParameter> pps=TokenManager.resolvePostParameters(gcfg.getCreatePostParameters(),null,cfg, inputTokens);
			client.applyPostRequest(pps);
		} else {
			client.applyGetRequest();
		}
		List<ExistingGallery> galsUpdated=loadExistingGalleries(cfg);
		if (galsUpdated.size()<=currentGalleries.size()) throw new IOException();
		for (ExistingGallery eg:currentGalleries) {
			galsUpdated.remove(eg);
		}
		return galsUpdated.remove(0);
	}
}
