package jbiu.io.remote;

import java.io.IOException;
import java.util.Iterator;

import util.exception.CancelException;

import model.DLInfo;
import model.transfer.EngineConfig;
import model.urlconfig.URLConfig;
import io.DefaultDownloaderConfig3;
import io.downloaders.action.Action;
import io.downloaders.newdownloader3.NewDownloader3;

public class RemoteDownloader extends NewDownloader3{

	public RemoteDownloader(DLInfo info, EngineConfig cfg) throws IOException {
		super(info, cfg);
	}

	@Override
	public void startTransfer() throws IOException, CancelException {
		DefaultDownloaderConfig3 dcfg=(DefaultDownloaderConfig3)cfg;
		
		String u=dlInfo.getUrl();
		if (cfg==null) {
			throw new IOException();
		} else {
			boolean urlMatched=dcfg.getUrlConfigs().size()==0;
			
			for (URLConfig urlcfg:dcfg.getUrlConfigs()) {
				if (urlcfg.matchesExpression(u)) {
					urlMatched=true;
					break;
				}
			}
			
			client.setFollowRedirects(true);
			client.setAutoReferer();
			client.setUrl(dlInfo.getUrl());
			
			if (urlMatched) {
				Iterator<Action> it= dcfg.getActions();
				
				while (it.hasNext()) {
					it.next().apply(client, dlInfo);
				}
				
			}
			dlInfo.setFileName(client.getUrl());
		}
	}
}
