package jbiu.io.uploaders;


import java.io.IOException;
import java.util.Iterator;

import jbiu.io.uploaders.actions.UploaderAction;
import jbiu.model.ULInfo;
import jbiu.model.UploaderConfig;

import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;


public class NewGenericUploader extends Uploader {

	private ShoshoneClient client;
	
	
	public NewGenericUploader(ULInfo dlInfo,UploaderConfig config) throws IOException {
		super(dlInfo, config);
		client=new ShoshoneClient(null,true);
	}

	@Override
	public void cancel() {
		client.cancel();
	}

	@Override
	public void startTransfer() throws IOException, CancelException {
//		try{
		client.setProxy(proxy);
		client.setFollowRedirects(true);
		client.setAutoReferer();
		client.setMaxRedirects(5);
		UploaderConfig config=(UploaderConfig)cfg;
		Iterator<UploaderAction> it=config.getActionIterator();
		while (it.hasNext()) {
			UploaderAction a=it.next();
			a.setClient(client);
			a.setUploader(this);
			a.resolveTokens();
			a.performAction();
		}
		
		client.closeConnection();
//		} catch (CancelException e) {
//			e.printStackTrace();
//			throw e;
//			
//		}
	}

	@Override
	public void updateCurrentBytes() {
		ulInfo.updateBytes(client.getTransferedBytes());		
	}

}
