package jbiu.io.uploaders;

import java.io.IOException;

import model.transfer.linkcollector.ILinkCollectorEntry;

import util.exception.CancelException;

import jbiu.model.TokenManager;
import jbiu.model.ULInfo;
import jbiu.model.UploaderConfig;

public class SimulatorClassic extends Uploader{
	public SimulatorClassic(ULInfo info,UploaderConfig cfg) {
		super(info, cfg);
	}
	boolean cancel,err=false;
	long bytes;
	
	@Override
	public void startTransfer() throws IOException,CancelException{
		cancel=false;
		TokenManager.resolve("$TEST", ulInfo, getCfg(), null);
		long bps=((info.getId()+1)*10)*1024;
		bytes=0;
		
		long size=ulInfo.getFileSize();
		
		while (bytes<size) {
			bytes+=bps;
			if (cancel) {
				ulInfo.reset();
				throw new CancelException();
			}
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
			}
		}

		
		ILinkCollectorEntry e=ulInfo.getCollectorEntry();
		e.setLink(0,ulInfo.getFileName()+ "viewlink");
		
		for (int i=1;i<getCfg().getLinkTypeCount();i++) {
			e.setLink(i, ulInfo.getFileName()+ "otherlink"+i);
		}
		if (err){
			err=false;
			throw new IOException();
		}
	}
	

	@Override
	public void updateCurrentBytes() {
		ulInfo.updateBytes(bytes);
	}

	@Override
	public void cancel() {
		cancel=true;
	}
}
