package jbiu.io.uploaders;

import java.io.IOException;

import model.transfer.linkcollector.ILinkCollectorEntry;

import shoshone.httpclient.MultipartFile;
import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;

import jbiu.model.ULInfo;
import jbiu.model.UploaderConfig;


public class SimulatorUploader extends Uploader {
	private ShoshoneClient sc;
	
	public SimulatorUploader(ULInfo ulInfo, UploaderConfig config) {
		super(ulInfo, config);
	}

	@Override
	public void startTransfer() throws IOException,CancelException{
		/*bps=100*1024;
		bytes=0;
		size=ulInfo.getFileSize();
		
		while (bytes<size) {
			bytes+=bps;
			if (cancel) throw new CancelException();
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
			}
		}

		ILinkCollectorEntry e=ulInfo.getCollectorEntry();
		e.setLink(0,ulInfo.getFileName()+ "viewlink");
		
		for (int i=1;i<getCfg().getLinkTypeCount();i++) {
			e.setLink(i, ulInfo.getFileName()+ "otherlink"+i);
		}*/
		
		sc=new ShoshoneClient("http://localhost/simulator_imagehost/upload.php");
		sc.createBoundary();
		sc.addMultipartFormData(new MultipartFile(sc, "file", "image/png", ulInfo.getFile()));
		sc.applyMultipartRequest();
		
		ILinkCollectorEntry e=ulInfo.getCollectorEntry();
		e.setLink(0,sc.getResponse());
		
		sc.closeConnection();
	}

	@Override
	public void cancel() {
		if (sc!=null) sc.cancel();
	}

	@Override
	public void updateCurrentBytes() {
		if (sc!=null) ulInfo.updateBytes(sc.getTransferedBytes());
		
	}

}
