package jbiu.io.uploaders.actions;

import java.io.IOException;

public class AddRequestPropertyAction extends UploaderAction {

	private String name,value;
	
	public AddRequestPropertyAction(String name,String value) {
		this.name=name;
		this.value=value;
	}
	
	@Override
	public void performAction() throws IOException {
		client.addRequestProperty(name, value);
	}

	@Override
	public void resolveTokens() throws IOException {
		value=getTokenValue(value);		
	}

	@Override
	public UploaderAction clone() {
		AddRequestPropertyAction copy= (AddRequestPropertyAction) super.clone();
		copy.name=new String(name);
		copy.value=new String(value);
		return copy;
	}

}
