package jbiu.io.uploaders.actions;

import java.io.IOException;
import java.util.Arrays;

import jbiu.model.token.TokenExtractor;


public class ExtractTokenAction extends UploaderAction {

	private String tokenName;
	private String[] extractorArgs;
	private TokenExtractor extractor;
	
	public ExtractTokenAction(String tokenName,TokenExtractor tokenExtractor, String[] args) {
		this.extractor=tokenExtractor;
		this.tokenName=tokenName;
		this.extractorArgs=args;
	}
	
	@Override
	public void resolveTokens() throws IOException {
		
	}

	@Override
	public void performAction() throws IOException {
		ulInfo.setFileToken(tokenName, extractor.getToken(client.getResponse(), extractorArgs));
	}

	@Override
	public UploaderAction clone() {
		ExtractTokenAction copy=(ExtractTokenAction) super.clone();
		copy.tokenName=new String(tokenName);
		copy.extractorArgs=Arrays.copyOf(extractorArgs, extractorArgs.length);
		copy.extractor=extractor;
		return copy;
	}

}
