package jbiu.io.uploaders.actions;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import jbiu.model.TokenManager;


import shoshone.httpclient.PostParameter;
import util.exception.CancelException;

public class PostAction extends UploaderAction {

	private List<PostParameter> params;
	
	public PostAction() {
		params=new ArrayList<>();
	}
	
	@Override
	public void resolveTokens() throws IOException {
		params=TokenManager.resolvePostParameters(params, ulInfo,config,null);
	}

	@Override
	public void performAction() throws IOException, CancelException {
		client.applyPostRequest(params);	
	}

	public void addPostParam(String name, String value) {
		params.add(new PostParameter(name, value));
	}

	@Override
	public UploaderAction clone() {
		PostAction copy=(PostAction) super.clone();
		copy.params=new ArrayList<>(params.size());
		
		for (PostParameter p:params) {
			PostParameter pcopy=p.clone();
			copy.params.add(pcopy);
		}
		return copy;
	}

}
