package jbiu.io.uploaders.actions;

import java.io.IOException;

public class SetTokenAction extends UploaderAction {

	private String name,value;
	
	public SetTokenAction(String name,String value) {
		this.name=name;
		this.value=value;
	}
	
	@Override
	public void performAction() throws IOException {
		if (name.startsWith("$HOST#")) {
			config.setHostToken(name,value);
		}
	}

	@Override
	public void resolveTokens() throws IOException {
		value=getTokenValue(value);
	}

	@Override
	public UploaderAction clone() {
		SetTokenAction copy=(SetTokenAction) super.clone();
		copy.name=new String(name);
		copy.value=new String(value);
		return copy;
	}

}
