package jbiu.io.uploaders.actions;

import java.io.IOException;

import jbiu.model.TokenManager;


public class SetURLAction extends UploaderAction {

	private String url;
	
	public SetURLAction(String url) {
		this.url=url;
	}
	
	@Override
	public void performAction() throws IOException {
		client.setUrl(url);
		client.createBoundary();
		if (config.getLoginInfo()!=null)client.addCookies(config.getCookies());
	}

	@Override
	public void resolveTokens() throws IOException {
		url=TokenManager.resolveUrl(url, ulInfo, config,null);
	}

	@Override
	public UploaderAction clone() {
		SetURLAction copy=(SetURLAction)super.clone();
		copy.url=new String(url);
		return copy;
	}

}
