package jbiu.io.uploaders.actions;


import java.io.IOException;

import jbiu.io.uploaders.Uploader;
import jbiu.model.TokenManager;
import jbiu.model.ULInfo;
import jbiu.model.UploaderConfig;


import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;

public abstract class UploaderAction implements Cloneable{
	
	protected ShoshoneClient client;
	protected Uploader uploader;
	protected ULInfo ulInfo;
	protected UploaderConfig config;
	
	public void setUploader(Uploader uploader) {
		this.uploader = uploader;
		config=uploader.getCfg();
		ulInfo=uploader.getUploadInfo();
	}
	
	public void setConfig(UploaderConfig config) {
		this.config = config;
	}
	
	public abstract void resolveTokens()  throws IOException;
	
	protected String getTokenValue(String token) throws IOException {
		return TokenManager.resolve(token, ulInfo,config,null);		
	}
	
	@Override
	public UploaderAction clone() {
		UploaderAction copy;
		try {
			copy = (UploaderAction)super.clone();
		} catch (CloneNotSupportedException e) {
			throw new RuntimeException(e);
		}
		return copy;
	}
	
	
	public void setClient(ShoshoneClient client) {
		this.client = client;
	}
	
	public UploaderConfig getConfig() {
		return config;
	}
	
	public ULInfo getUlInfo() {
		return ulInfo;
	}
	
	public abstract void performAction() throws IOException, CancelException;
		
}
