package jbiu.io.uploaders.actions;

import java.io.IOException;

import shoshone.httpclient.MultipartField;

public class WriteFieldAction extends UploaderAction {

	private String fieldName,value;
	
	public WriteFieldAction(String fieldName,String value) {
		this.fieldName=fieldName;
		this.value=value;
	}
	
	@Override
	public void performAction() throws IOException {
		client.addMultipartFormData(new MultipartField(client, fieldName, value));
	}

	@Override
	public void resolveTokens() throws IOException {
		value=getTokenValue(value);
	}

	@Override
	public UploaderAction clone() {
		WriteFieldAction copy=(WriteFieldAction) super.clone();
		copy.fieldName=new String(fieldName);
		copy.value=new String(value);
		return copy;
	}

}
