package jbiu.io.uploaders.actions;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;

import shoshone.httpclient.MultipartFile;

public class WriteFileAction extends UploaderAction {

	private String name,value;
	private Path file;
	
	public WriteFileAction(String name,String value) {
		this.name=name;
		this.value=value;
	}
	
	@Override
	public void performAction() throws IOException {
		client.addMultipartFormData(new MultipartFile(client, name, value, file));
	}

	@Override
	public void resolveTokens() throws IOException {
		file=ulInfo.getFile();
		value=getTokenValue(value);
	}

	@Override
	public UploaderAction clone() {
		WriteFileAction copy=(WriteFileAction) super.clone();
		copy.name=new String(name);
		copy.value=new String(value);
		if (file!=null)
		copy.file=Paths.get(file.toString());
		return copy;
	}

}
