package jbiu.io.uploaders.actions.condition;

import java.io.IOException;

import shoshone.httpclient.ShoshoneClient;
import util.exception.CancelException;

import jbiu.io.uploaders.Uploader;
import jbiu.io.uploaders.actions.UploaderAction;
import jbiu.model.UploaderConfig;

public class ConditionalAction extends UploaderAction {

	private UploaderAction a;
	private Condition cond;
	
	public ConditionalAction(UploaderAction a,Condition cond) {
		this.a=a;
		this.cond=cond;
	}
	
	@Override
	public void resolveTokens() throws IOException {
		a.resolveTokens();
	}

	@Override
	public void performAction() throws IOException, CancelException {
		if (cond.meetsCondition()) a.performAction();
	}

	@Override
	public void setClient(ShoshoneClient client) {
		a.setClient(client);
	}
	
	@Override
	public void setConfig(UploaderConfig config) {
		a.setConfig(config);
	}
	
	@Override
	public void setUploader(Uploader uploader) {
		a.setUploader(uploader);
	}
	
	@Override
	public ConditionalAction clone() {
		ConditionalAction copy=(ConditionalAction) super.clone();
		copy.a=a.clone();
		copy.cond=cond.clone();
		copy.cond.setParentAction(copy);
		return copy;
	}
	
	public UploaderAction getAction() {
		return a;
	}
}
