/*	This program is released under GNU General Public License (see COPYING).
 *  It comes AS IS and without any warranty 
 *  (C) 2010,2011 TCM, Open Source Maniax
 */

package jbiu.model;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

import model.transfer.TransferEngine;
import model.transfer.TransferInfo;

import util.exception.CancelException;

import jbiu.io.ConfigLoader2;
import jbiu.io.uploaders.SimulatorUploader;


public class ConfigModel {
	
	private static Map<String, UploaderConfig> cfgs;
	private static UploaderConfig simulator;
	
	static {
		simulator=new UploaderConfig(){
			@Override
			public TransferEngine getEngine(TransferInfo ulInfo) throws IOException {
				return new SimulatorUploader((ULInfo) ulInfo,this);
			}
		};
		for (int i=0;i<4;i++)
			simulator.addLinkConfig(new LinkConfig(null, null) );
		
	}
	
	private static void reset(){
		if (cfgs != null)
			cfgs.clear();
	}
	
	
	
	public static UploaderConfig getSimulator(){
		return simulator;
	}
	
	public static boolean checkForUpdates() throws IOException, CancelException {
		
		boolean b= ConfigLoader2.downloadUpdates();
		if (b)reset();
		return b;
	}

	public static List<UploaderConfig> getAllConfigs() {
		if (cfgs == null) cfgs = ConfigLoader2.load();
		List<UploaderConfig> cfg=new ArrayList<>(cfgs.size());
		
		for (UploaderConfig uc:cfgs.values()) {
			cfg.add(uc);
		}
		return Collections.unmodifiableList(cfg);
	}
	
	
	public static UploaderConfig getUploaderConfig(String host) {
		if (cfgs == null) cfgs = ConfigLoader2.load();
		return cfgs.get(host);
	}

//	public static List<String[]> getModifiers() {
//		if (modifiers==null) modifiers=ConfigLoader2.getModifiers();
//		return modifiers;
//	}
	
	
}
