/*	This program is released under GNU General Public License (see COPYING).
 *  It comes AS IS and without any warranty 
 *  (C) 2010,2011 TCM, Open Source Maniax
 */

package jbiu.model;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;

import jbiu.io.account.AccountManager;
import jbiu.model.template.LinkTemplate;
import jbiu.model.util.Util;


import settings.Settings;

public class JBIUModel {
	private static Settings settings;
	private static List<LinkTemplate> modifiers;
	private static UploadManager uploadManager;
	
	public static void init(Settings settings,UploadManager uploadManager,List<LinkTemplate> mods) throws IOException {
		AccountManager.setSuperPassword(Util.PW);
		JBIUModel.settings=settings;
		JBIUModel.uploadManager=uploadManager;
		modifiers=mods;
	}
	
	public static UploadManager getUploadManager() {
		return uploadManager;
	}
	
	public static Settings getSettings() {
		return settings;
	}

	public static int getMaxThreads() {
		return settings.getInt("maxThreads");
	}
	
	public static int getMaxTries() {
		return settings.getInt("maxTries");
	}
	
	public static String getHost(String urlString) throws MalformedURLException {
		URL url=new URL(urlString);
		String u=url.getHost().toLowerCase();
		
		char dot='.';
		
		int k1=u.lastIndexOf(dot);
		int k2=u.lastIndexOf(dot, k1-1);
		if (k2>-1) {
			return u.substring(k2+1);
		} else {
			return u;
		}
	}

	public static List<LinkTemplate> getModifiers() {
		return modifiers;
	}
	
	public static LinkTemplate getModifierByValue(String value) {
		if (value!=null) {
			for(LinkTemplate tpl:modifiers) {
				if (tpl.getValue2().equals(value))
					return tpl;
			}
		}
		return null;
	}
	
}
