package jbiu.model;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import shoshone.httpclient.Cookie;
import shoshone.httpclient.RequestProperty;
import util.Pair;

public class LoginInfo {
	private String url,logoutUrl;
	private List<Pair<String,String>> loginParams;
	private String expectedCookieName,loginResponse;
	private List<RequestProperty> requestProperties;
	private int expectedCode;
	private boolean passiveLogin,loggedIn;
		
	public void setPassiveLogin() {
		this.passiveLogin = true;
	}
	
	public boolean isPassiveLogin() {
		return passiveLogin;
	}
	
	public void setExpectedCookieName(String expectedCookieName) {
		this.expectedCookieName = expectedCookieName;
	}
	
	public String getExpectedCookieName() {
		return expectedCookieName;
	}
	
	public LoginInfo() {
		loginParams = new LinkedList<>(); 
		expectedCode=-1;
	}
	
	public void setURL(String url) {
		this.url=url;
	}
	
	public String getURL() {
		return url;
	}

	public void addParam(String name, String value) {
		loginParams.add(new Pair<>(name, value));
	}
	
	public List<Pair<String,String>> getLoginParams() {
		return loginParams;
	}

	public void login(Set<Cookie> cookies) {
		if (cookies!=null||passiveLogin)
			loggedIn=true;
	}
	
	public void logout() {
		loggedIn=false;
	}

	public void addRequestProperty(String name, String value) {
		if (requestProperties==null) requestProperties=new LinkedList<RequestProperty>();
		requestProperties.add(new RequestProperty(name, value) );
	}
	
	public Iterator<RequestProperty> getRequestProperties() {
		if (requestProperties!=null)
			return requestProperties.iterator();
		else
			return null;
	}

	public void setLoginExpectCode(int code) {
		expectedCode=code;
	}
	
	public int getExpectedCode() {
		return expectedCode;
	}
	
	public String getLogoutUrl() {
		return logoutUrl;
	}
	
	public void setLogoutUrl(String logoutUrl) {
		this.logoutUrl = logoutUrl;
	}
	
	public boolean isLoggedIn() {
		return loggedIn;
	}

	public void setLoginResponse(String value) {
		loginResponse=value;
	}
	
	public String getLoginResponse() {
		return loginResponse;
	}

}
