package jbiu.model;

import java.io.IOException;
import java.util.List;
import java.util.Map;


import shoshone.httpclient.PostParameter;


public class TokenManager {
	
	private static char TOKEN_ID = '$';
	private static char STRING_CONCAT = '§';
	
	public static String resolve(String token,ULInfo ulInfo, UploaderConfig cfg, Map<String, String> inputTokens) throws IOException {
		String value=token;
		
		if (value == null) {
			throw new IOException();
		} else {
			while (value.length()>0&&  value.charAt(0)==TOKEN_ID) {
				if (value.startsWith("$FILE#")) {
					if (ulInfo!=null) {
						value=ulInfo.getFileToken(token);
					} else if (inputTokens!=null){
						value = inputTokens.get(token);
					}
				} else if (value.equals(GlobalTokens.MIME)) {
					value= GlobalTokens.getMime(ulInfo.getFile());
				} else if (value.equals(GlobalTokens.EMPTY)) {
					value= GlobalTokens.getEmpty();	
				} else if (value.equals(GlobalTokens.FILE_NAME)) {
					value= ulInfo.getFileName();	
				} else if (value.startsWith("$HOST#")) {
					if (cfg!=null) {
						value=cfg.getToken(token);
					} else if (inputTokens!=null){
						value = inputTokens.get(token);
					} else {
						throw new IOException();
					}
				} else if (value.startsWith(GlobalTokens.VAL_OF_COOKIE)) {
					value=cfg.getCookieValue(value.substring(token.indexOf('#')+1));
				} else if (value.startsWith(GlobalTokens.RND)) {
					value=GlobalTokens.getRnd(Integer.parseInt(value.substring(token.indexOf('#')+1)));
				} else {
					throw new IOException();
				}

				if (value==null) {
					System.out.println(token + " "+ ulInfo.getFileTokens()+ " "+cfg.getTokens());
					throw new IOException();
				}
			}
			return value;
		}
	}
	
	public static String resolveUrl(String url,ULInfo ulInfo, UploaderConfig cfg, Map<String, String> tokens) throws IOException {
		return resolveConcatted(url, ulInfo, cfg, tokens);
	}
	
	private static String resolveConcatted(String concattedToken,ULInfo ulInfo, UploaderConfig cfg, Map<String, String> tokens) throws IOException {
		if (concattedToken.indexOf(STRING_CONCAT)>-1) {
			StringBuilder sb=new StringBuilder();
			String[] urlParts=concattedToken.split(Character.toString(STRING_CONCAT));
			
			for (String part:urlParts ) {
				sb.append(resolve(part,ulInfo,cfg,tokens));
			}
			return sb.toString();
		} else {
			return resolve(concattedToken, ulInfo, cfg, tokens);
		}
	}
	
	public static String resolveUrl(String url,Map<String, String> tokens) throws IOException {
		return resolveUrl(url, null, null, tokens);
	}
	
	public static List<PostParameter> resolvePostParameters(List<PostParameter> params,ULInfo ulInfo, UploaderConfig cfg, Map<String, String> additionalTokens) throws IOException {
		for (PostParameter p:params) {
			p.setName(resolveConcatted(p.getName(), ulInfo, cfg, additionalTokens));
			p.setValue(resolveConcatted(p.getValue(), ulInfo, cfg, additionalTokens));		
		}
		return params;
	}
}
