package jbiu.model;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardOpenOption;
import java.util.ArrayList;
import java.util.List;

import util.CollectionUtil;

import core.io.Application;

import jbiu.model.template.LinkTemplate;
import jbiu.model.template.LinkTemplateToken;

import model.transfer.linkcollector.ILinkCollectorEntry;
import model.transfer.linkcollector.LinkCollector;

public class UploadLinkCollector extends LinkCollector {
	
	public List<String> getLinks(int index,LinkTemplate tmpl) {
		List<String> list=new ArrayList<>();

		for (ILinkCollectorEntry e:entries) {
			list.add(tmpl.apply(e.getLink(index),getLinkTemplateTokens(e)));
		}
		return list;
	}
	
	public List<String> getLinks(int linkIndices[],int typeIndex,LinkTemplate tmpl){
		List<String> list=new ArrayList<>();

		int i=0;
		int j=0;
		for (ILinkCollectorEntry e:entries) {
			if (i==linkIndices[j]){
				list.add(tmpl.apply(e.getLink(typeIndex),getLinkTemplateTokens(e)));
				j++;
			}
			i++;
		}
		return list;
	}
	
	protected List<LinkTemplateToken> getLinkTemplateTokens(ILinkCollectorEntry entry){
		ArrayList<LinkTemplateToken> list=new ArrayList<>();
		list.add(new LinkTemplateToken("$VIEWLINK$",entry.getLink(0)));
		return list;
	}
	
	public void save(Path p,int index,boolean append,LinkTemplate tmpl) throws IOException {
		List<String> links = getLinks(index, tmpl);
		
		StandardOpenOption[] opt=append?new StandardOpenOption[]{StandardOpenOption.APPEND,StandardOpenOption.CREATE,StandardOpenOption.WRITE}:Application.DEFAULT_WRITE_OPTIONS;
		
		BufferedOutputStream out=new BufferedOutputStream( Files.newOutputStream(p,opt));
		if (append&&Files.size(p)>0) out.write('\n');
		
		out.write(CollectionUtil.concat("\n", links).getBytes(Application.UTF8));
		out.close();
	}
}
