package jbiu.model.token;

import java.io.IOException;

import net.util.LinkExtractor;

public abstract class TokenExtractor {
	public abstract String getToken(String html,String[] args) throws IOException;
	public static TokenExtractor getTokenExtractor(String type) {
		if (type.equals("keyStartEnd")) {
			return new TokenExtractorKeyStartEnd();
		} else if (type.equals("id")) {
			return new TokenExtractorId();
		} else if (type.equals("attr")) {
			return new TokenExtractorHTMLAttribute();
		} else if (type.equals("noChange")) {
			return new TokenExtractorNoChange();
		}
		return null;
	}
	
	public static String preFilterHtml(String html) {
		return LinkExtractor.preFilterHtml(html);
	}
	public abstract String[] getArgNames();
}
