/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package model;

import java.nio.file.Files;
import java.nio.file.Path;

import model.transfer.TransferInfo;

public class DLInfo extends TransferInfo {

	protected Path output;
	protected long fileSize;
	protected String url;
	protected String fileName;
	protected boolean disableTypeCheck;
	
	public DLInfo(String url,Path output,String fileName) {
		this(url, output);
		this.fileName=fileName;
	}
	
	public DLInfo(String url,Path output) {
		this.output=output;
		this.url=url;
		this.fileSize=-1;
	}
	
	public String getUrl() {
		return url;
	}
	
	public void setFileSize(long fileSize) {
		this.fileSize = fileSize;
	}
	
	public long getFileSize() {
		return fileSize;
	}
	
	public void setFileName(String fileName) {
		Path out=output.resolve(fileName);
		if (Files.exists(out)) {
			int k=fileName.lastIndexOf('.');
			
			if (k>-1) {
				String f=fileName.substring(0,k);
				String ext=fileName.substring(k);
				int i=2;
				while (Files.exists(out)) {
					out=output.resolve(f+"("+i+")"+ext);
					i++;
				}
			} else {
				int i=2;
				while (Files.exists(out)) {
					out=output.resolve(fileName+"("+i+")");
				}
			}
		}
		this.fileName=fileName;
	}
	
	public Path getOutputFile() {
		if (fileName!=null){
			Path out=output.resolve(fileName);
			return out;
		} else {
			return null;
		}
	}
	
	public Path getOutputPath() {
		return output;
	}

	public String getFileName() {
		return fileName;
	}

	public void disableTypeCheck() {
		disableTypeCheck = true;
	}
	
	public boolean typeCheckDisabled() {
		return disableTypeCheck;
	}

}
