package model.transfer.linkcollector;


import java.nio.file.Path;


public class LinkCollectorEntry implements ILinkCollectorEntry {
	private Path file;
	private String singleLink;
	private String[] multipleLinks;
	private long size;
	private int count;	
	
	public void setFile(Path file) {
		this.file = file;
	}
	
	@Override
	public void setLink(int index, String link) {
		if (multipleLinks==null) {
			if (index==0)
				singleLink = link;
		} else {
			multipleLinks[index]= link;
		}
	}

	@Override
	public String getLink(int index) {
		if (multipleLinks==null) {
			return singleLink;
		} else {
			return multipleLinks[index];
		}
	}
	
	public LinkCollectorEntry(int linksCount) {
		if (linksCount>1) multipleLinks = new String[linksCount];
		this.count=linksCount;
	}
	
	public int getLinkTypeCount() {
		return count;
	}
	
	public static ILinkCollectorEntry singleLink() {
		return new LinkCollectorEntry(1);
	}

	@Override
	public long getSize() {
		return size;
	}
	
	@Override
	public void setSize(long size) {
		this.size=size;
	}

	@Override
	public Path getFile() {
		return file;
	}

}
