/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package net.util;

import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;

import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;

public class Proxy {
	
	public static final int HTTP_PROXY=0;
	public static final int SOCKS5_PROXY=1;
	
	private int port;
	private String host;
	private int type;
	
	private static Proxy noProxy=new Proxy(null, -1,-1);
	
	private Proxy(String host,int port,int type) {
		this.host=host;
		this.port=port;
		this.type=type;
	}
	
	public String getHost() {
		return host;
	}
	
	public int getPort() {
		return port;
	}
	
	public static Proxy httpProxy(String host,int port)  {
		return new Proxy(host,port,HTTP_PROXY);
	}
	
	public static Proxy socks5Proxy(String host,int port)  {
		return new Proxy(host,port,SOCKS5_PROXY);
	}
	
	public static Proxy noProxy() {
		return noProxy;
	}
	
	protected Socket createSocket(InetAddress inetAddress,String protocol) throws IOException {
		if (protocol.equals("http")){
			return new Socket(inetAddress, 80);
		} else if (protocol.equals("https")){
			return(SSLSocket) SSLSocketFactory.getDefault().createSocket(inetAddress, 443);
		}
		return null;
	}
	
	public int getType() {
		return type;
	}
}
