package net.util;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;

public class TypeCheck {
	public static boolean checkPNGMagicNumber(Path p) throws IOException {
		BufferedInputStream in=new BufferedInputStream(Files.newInputStream(p),8);
		try{
			int[] pngMagic={0x89, 0x50,0x4E,0x47, 0x0D, 0x0A, 0x1A, 0x0A};
			for(int k=0;k<8;k++) {
				int b=in.read();
				if (b==-1 || b!=pngMagic[k]){
					return false;
				}
			}
			return true;
		} finally {
			in.close();
		}
	}
	
	public static boolean checkPNGMagicNumberSuppressException(Path p) {
		try {
			return checkPNGMagicNumber(p);
		} catch (IOException e) {
			return false;
		}
	}
}
