package util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class CollectionUtil {
	@SafeVarargs
	public static <E> ArrayList<E> arrayList(E...elements) {
		ArrayList<E> list= new ArrayList<E>();
		for(int i=0;i<elements.length;i++)
			list.add(elements[i]);
		return list;
	}
	
	public static <E> ArrayList<E> arrayList(E e) {
		ArrayList<E> list= new ArrayList<E>();
		list.add(e);
		return list;
	}
	
	public static <T> String concat(String separator, List<T> list) {
		if (list.size()>0) {
			Iterator<T> it=list.iterator();
			
			StringBuilder sb=new StringBuilder(it.next().toString());
			
			while(it.hasNext()){
				sb.append(separator);
				sb.append(it.next());
			}
			return sb.toString();
		} else
			return "";
	}
}
