package util;

public class LongRingBuffer {
	private long[] arr;
	private int pos;
	private final int CAP;
	private int fillLevel;
	
	public LongRingBuffer(int cap) {
		CAP=cap;
		arr=new long[CAP];
	}
	
	public void put(long l) {
		if (fillLevel<CAP) fillLevel++;
		arr[pos]=l;
		pos=(pos+1)%CAP;
	}
	
	public int getFillLevel() {
		return fillLevel;
	}
	
	public long[] getArr() {
		long[] cp=new long[fillLevel];
		System.arraycopy(arr, 0, cp, 0, fillLevel);
		return cp;
	}
}
