package util.base64;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

public class GzipPlusBase64Coder {
	public static String toGzipPlusBase64(byte[] bytes) throws IOException{
		ByteArrayOutputStream bout=new ByteArrayOutputStream();
		GZIPOutputStream out=new GZIPOutputStream(bout);
		out.write(bytes);
		out.flush();
		out.finish();
		out.close();
		return Base64Encoder.encode(bout.toByteArray());
	}
	
	public static byte[] fromGzipPlusBase64(String base64) throws IOException {
		byte[] gzip=Base64Decoder.decode(base64);
		BufferedInputStream in=new BufferedInputStream(new GZIPInputStream(new ByteArrayInputStream(gzip)));
		int r;
		ByteArrayOutputStream out=new ByteArrayOutputStream();
		while ((r= in.read())>-1)  {
			out.write(r);
		}
		return out.toByteArray();
	}
}
